#ifndef TRPCLONG_GENERAL_WRAPPER_HEADER_H
#define TRPCLONG_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "dpc_trpc_long/executable.h"
#include "TRPCLong_PubDataWrapper.h"
#include "TRPCLong_SubDataWrapper.h"

using namespace jac::ap::trpclongservice::skeleton;
using namespace jac::ap::dmservice::proxy;
using namespace jac::ap::vedservice::proxy;
using namespace jac::ap::emservice::proxy;
using namespace jac::ap::canservice::proxy;

GENERATE_PUB_WRAPPER(TRPCLong2CAN_Provide, TRPCLong2CAN_PubDataWrapper, TRPCLongServiceSkeleton,  SWC2CAN, TRPCLong2CANEvent);
GENERATE_SUB_WRAPPER(VED2TRPCLong_Required, VED2TRPCLong_SubDataWrapper, VEDServiceProxy, dpc::VED4DPC, VED4DPCEvent, "11", 10);
GENERATE_SUB_WRAPPER(DM2TRPCLong_Required, DM2TRPCLong_SubDataWrapper, DMServiceProxy, dpc::Decision4Long, Decision4LongEvent , "40", 10);
GENERATE_SUB_WRAPPER(EM2TRPCLongTargetsInfo_Required, EM2TRPCLongTargetsInfo_SubDataWrapper, EMServiceProxy, dpc::TargetsInfo, TargetsInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2TRPCLongTargetInfo_Required, EM2TRPCLongTargetInfo_SubDataWrapper, EMServiceProxy, dpc::TargetInfo, TargetInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2TRPCLongRoadEdgeInfo_Required, EM2TRPCLongRoadEdgeInfo_SubDataWrapper, EMServiceProxy, dpc::RoadEdgeInfo, RoadEdgeInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2TRPCLongLaneMarkerInfo_Required, EM2TRPCLongLaneMarkerInfo_SubDataWrapper, EMServiceProxy, dpc::LaneMarkerInfo, LaneMarkerInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(CAN2Long_Required, CAN2Long_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);
GENERATE_SUB_WRAPPER(DM2LongRefLine_Required, DM2LongRefLine_SubDataWrapper, DMServiceProxy, dpc::DM2LongRefLine, DM2LongRefLineEvent, "40", 10);

class GeneralWrapper {
public:
    TRPCLong2CAN_Provide _TRPCLong2CAN_Provide;
    VED2TRPCLong_Required  _VED2TRPCLong_Required;
    DM2TRPCLong_Required  _DM2TRPCLong_Required;
    EM2TRPCLongTargetsInfo_Required  _EM2TRPCLongTargetsInfo_Required;
    EM2TRPCLongTargetInfo_Required  _EM2TRPCLongTargetInfo_Required;
    EM2TRPCLongRoadEdgeInfo_Required  _EM2TRPCLongRoadEdgeInfo_Required;
    EM2TRPCLongLaneMarkerInfo_Required  _EM2TRPCLongLaneMarkerInfo_Required;
    CAN2Long_Required _CAN2Long_Required;
    DM2LongRefLine_Required _DM2LongRefLine_Required;

    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};

#endif
